﻿using System;
using System.IO;
using System.Text.RegularExpressions;
using System.Collections.Generic;

namespace Assembler
{
    class Program
    {
        static void Main(string[] args)
        {
            if (args.Length == 0)
            {
                Console.WriteLine("Leevin Hack - assembler");
                Console.WriteLine("Käyttö: Assembler <input file path>");
                return;
            }

            try
            {


                string[] tiedostoListana = File.ReadAllLines(args[0]);

                List<string> parsittuTiedosto = new List<string>();

                //poistaa kommentit
                for (int i = 0; i < tiedostoListana.Length; i++)
                {
                    string rivi = tiedostoListana[i];
                    rivi = rivi.Replace("\t", "");
                    rivi = rivi.Replace("\n", "");
                    rivi = rivi.Replace("\r", "");
                    string[] rivit = rivi.Split("//");
                    
                    if (rivit[0].Length > 0) parsittuTiedosto.Add(rivit[0]);
                }


                //c-käskyt
                for (int i = 0; i < parsittuTiedosto.Count; i++)
                {
                    string rivi = parsittuTiedosto[i];
                    string comp ="";
                    string dest ="";
                    string jump ="";

                    if (rivi.Contains("@")) continue;
                    if (rivi.Contains("(")) continue;

                    int jumpAlku = rivi.IndexOf(";");
                    int compAlku = rivi.IndexOf("=");
                    String[] kaskyt = rivi.Split(new char[] { '=', ';' });

                    if ( compAlku < 0 )
                    {
                        comp = kaskyt[0];
                        jump = kaskyt[1];
                    }

                    if ( jumpAlku < 0)
                    {
                        dest = kaskyt[0];
                        comp = kaskyt[1];
                    }

                    if ((jumpAlku > 0) && (compAlku > 0))
                    {
                       
                        dest = kaskyt[0];
                        comp = kaskyt[1];
                        jump = kaskyt[2];
                    }


                    parsittuTiedosto[i] = "111" + ParseDest(dest) + ParseComp(comp) + ParseJump(jump);

                    

                }

                //labelit kuntoon
                for (int i = 0; i < parsittuTiedosto.Count; i++)
                {
                    string rivi = parsittuTiedosto[i];
                    if (rivi.Contains("("))
                    {
                        int sulkuAlku = rivi.IndexOf("(");
                        int sulkuLoppu = rivi.IndexOf(")");
                        if (sulkuLoppu < 0) throw new Exception($"unclosed label at line {rivi}");
                        int labelPituus = sulkuLoppu - sulkuAlku;
                        string label = rivi.Substring(sulkuAlku+1, labelPituus-1);

                        for (int j = 0; j < parsittuTiedosto.Count; j++)
                        {
                            string aKasky = parsittuTiedosto[j];
                            if (!aKasky.Contains("@")) continue;
                            string riviNum = i.ToString();
                            if (aKasky.Equals("@"+label)) parsittuTiedosto[j] = "@" + riviNum;
                        }
                        parsittuTiedosto.Remove(rivi);
                                
                        }

                }

                //a-käskyt kuntoon
                for (int i = 0; i < parsittuTiedosto.Count; i++)
                {
                    string rivi = parsittuTiedosto[i];
                    if (!rivi.Contains("@")) continue;
                    short arvo =0;
                    switch (rivi.Substring(1))
                    {
                        case "SP":
                            arvo = 0;
                            parsittuTiedosto[i] = Muuta16Binary(arvo);
                            continue;
                        case "LCL":
                            arvo = 1;
                            parsittuTiedosto[i] = Muuta16Binary(arvo);
                            continue;
                        case "ARG":
                            arvo = 2;
                            parsittuTiedosto[i] = Muuta16Binary(arvo);
                            continue;
                        case "THIS":
                            arvo = 3;
                            parsittuTiedosto[i] = Muuta16Binary(arvo);
                            continue;
                        case "THAT":
                            arvo = 4;
                            parsittuTiedosto[i] = Muuta16Binary(arvo);
                            continue;
                        case "R0":
                            arvo = 0;
                            parsittuTiedosto[i] = Muuta16Binary(arvo);
                            continue;
                        case "R1":
                            arvo = 1;
                            parsittuTiedosto[i] = Muuta16Binary(arvo);
                            continue;
                        case "R2":
                            arvo = 2;
                            parsittuTiedosto[i] = Muuta16Binary(arvo);
                            continue;
                        case "R3":
                            arvo = 3;
                            parsittuTiedosto[i] = Muuta16Binary(arvo);
                            continue;
                        case "R4":
                            arvo = 4;
                            parsittuTiedosto[i] = Muuta16Binary(arvo);
                            continue;
                        case "R5":
                            arvo = 5;
                            parsittuTiedosto[i] = Muuta16Binary(arvo);
                            continue;
                        case "R6":
                            arvo = 6;
                            parsittuTiedosto[i] = Muuta16Binary(arvo);
                            continue;
                        case "R7":
                            arvo = 7;
                            parsittuTiedosto[i] = Muuta16Binary(arvo);
                            continue;
                        case "R8":
                            arvo = 8;
                            parsittuTiedosto[i] = Muuta16Binary(arvo);
                            continue;
                        case "R9":
                            arvo = 9;
                            parsittuTiedosto[i] = Muuta16Binary(arvo);
                            continue;
                        case "R10":
                            arvo = 10;
                            parsittuTiedosto[i] = Muuta16Binary(arvo);
                            continue;
                        case "R11":
                            arvo = 11;
                            parsittuTiedosto[i] = Muuta16Binary(arvo);
                            continue;
                        case "R12":
                            arvo = 12;
                            parsittuTiedosto[i] = Muuta16Binary(arvo);
                            continue;
                        case "R13":
                            arvo = 13;
                            parsittuTiedosto[i] = Muuta16Binary(arvo);
                            continue;
                        case "R14":
                            arvo = 14;
                            parsittuTiedosto[i] = Muuta16Binary(arvo);
                            continue;
                        case "R15":
                            arvo = 15;
                            parsittuTiedosto[i] = Muuta16Binary(arvo);
                            continue;
                        case "SCREEN":
                            arvo = 16384;
                            parsittuTiedosto[i] = Muuta16Binary(arvo);
                            continue;
                        case "KBD":
                            arvo = 24576;
                            parsittuTiedosto[i] = Muuta16Binary(arvo);
                            continue;

                        default:
                            Int16.TryParse(rivi.Substring(1), out arvo);
                            parsittuTiedosto[i] = Muuta16Binary(arvo);
                            continue;

                    }



                }







                for (int i = 0; i< parsittuTiedosto.Count; i++)
                {
                    string rivi = parsittuTiedosto[i];

                }


                foreach (string rivi in parsittuTiedosto)
                {
                    Console.WriteLine(rivi);
                }

                Console.ReadLine();
            }
            catch (Exception e)
            {
                Console.WriteLine(e);
            }


            
        }

        
        public static string ParseComp(string comp)
        {
            switch (comp){

                case "0":
                    return "0101010";    
                case "1":
                    return "0111111";
                case "-1":
                    return "0111010";
                case "D":
                    return "0001100";
                case "A":
                    return "0110000";
                case "!D":
                    return "0001101";
                case "!A":
                    return "0110001";
                case "-D":
                    return "0001111";
                case "-A":
                    return "0110011";
                case "D+1":
                    return "0011111";
                case "A+1":
                    return "0110111";
                case "D-1":
                    return "0001110";
                case "A-1":
                    return "0110010";
                case "D+A":
                    return "0000010";
                case "D-A":
                    return "0010011";
                case "A-D":
                    return "0000111";
                case "D&A":
                    return "0000000";
                case "D|A":
                    return "0010101";
                case "M":
                    return "1110000";
                case "!M":
                    return "1110001";
                case "-M":
                    return "1110011";
                case "M+1":
                    return "1110111";
                case "M-1":
                    return "1110010";
                case "D+M":
                    return "1000010";
                case "D-M":
                    return "1010011";
                case "M-D":
                    return "1000111";
                case "D&M":
                    return "1000000";
                case "D|M":
                    return "1010101";
                default:
                    return "error";
            }
        }

        public static string ParseDest(string dest)
        {
            switch (dest)
            {
                case "null":
                    return "000";
                case "M":
                    return "001";
                case "D":
                    return "010";
                case "MD":
                    return "011";
                case "A":
                    return "100";
                case "AM":
                    return "101";
                case "AD":
                    return "110";
                case "AMD":
                    return "111";
                default:
                    return "000";
            }
        }

       public static string ParseJump(string jump)
        {
            switch (jump)
            {
                case "null":
                    return "000";
                case "JGT":
                    return "001";
                case "JEQ":
                    return "010";
                case "JGE":
                    return "011";
                case "JLT":
                    return "100";
                case "JNE":
                    return "101";
                case "JLE":
                    return "110";
                case "JMP":
                    return "111";
                default:
                    return "000";
            }
        }

        public static string Muuta16Binary(short arvo)
        {
            string binary = Convert.ToString(arvo, 2);
            return String.Format("{0:0000000000000000}", binary).PadLeft(16, '0');

        }

    }
}
